C***********************************************************************
C $Id: arnlo.f,v 3.3 2009/03/03 13:38:11 nils Exp $

      DOUBLE PRECISION FUNCTION ARNLO(I1,I2,I3,PT2,NEMIT)

C...ARiadne function to deal with NLO matrix element events

C...This function generates the approriate Sudakov form factor and a
C...cascade for events from an NLO matrix element. The function also
C...generates weights for tree-level matrix element events which are to
C...be combinded with the NLO events.

      INCLUDE 'arimpl.f'
      INCLUDE 'arpart.f'
      INCLUDE 'ardips.f'
      INCLUDE 'arstrs.f'
      INCLUDE 'ardat1.f'
      INCLUDE 'arhide.f'
      INCLUDE 'pydat1.f'

      DIMENSION I1(5),I2(5),I3(5),PT2(5),PT(0:6)


      ARNLO=1.0D0

C...Get the number of steps we have to go back
      PT(0)=0.0
      IF ( MHAR(160).EQ.1 ) PT(0)=DBLE(PHAR(161))
      PT(NEMIT+1)=DBLE(PARA(40))

C...First go backward reconstructing the sequence
      DO 100 IEMIT=1,NEMIT
        PT(IEMIT)=SQRT(PT2(IEMIT))
        CALL ARUNDO(I1(IEMIT),I2(IEMIT),I3(IEMIT))
        CALL ARPUTR(10-IEMIT)
 100  CONTINUE

C...Remember number of emissions for running and fixed coupling.
      IEMIR=0
      IEMIF=0
C...Number of emissions for extra term in NNLO correction
      IEMIF2=0

C********************* Lambda QCD of ME alphas ***************
      XLQCD=DBLE(PHAR(167))/EXP(6.0D0*PARU(1)/(23.0D0*DBLE(PHAR(160))))
C*************************************************************

C...Count the number of emissions with a fixed coupling constant.
      IF(MHAR(188).GE.2.AND.MHAR(162).GT.0)THEN
        PARA2=PARA(2)
        MSTA12=MSTA(12)
        PARA(2)=phar(160)
        MSTA(12)=0
        DO 150 IEMIT=NEMIT,0,-1

          CALL ARGETR(10-IEMIT)
          NP=IPART
          IF ( MSTA(28).NE.0 ) THEN
            DO 160 I=1,IPART
              IF ( .NOT.QQ(I) ) PT2GG(I)=PT(IEMIT+1)**2
 160        CONTINUE
          ENDIF
          IO = MHAR(161)-MHAR(162)-IEMIT
          PTMAX=PT(IEMIT+1)
 170      CALL AREVO1(PTMAX,MAX(PT(IEMIT),DBLE(PHAR(168))))
          IF ( IPART.GT.NP ) THEN
            IF ( ARMECU(NP+1,IPART).GT.0.0D0 ) then
              IEMIF=IEMIF+1
              IF(MHAR(188).EQ.3)THEN
c                IF(PYR(IDUM).LT.LOG(PHAR(167)**2/PT2LST)/(2.0D0*
c     $            LOG(PHAR(167)/PHAR(168)))) IEMIF2=IEMIF2+1
                IF(PYR(IDUM).LT.LOG(PHAR(167)**2*PARA(1)**2/
     $              (PT2LST*XLQCD**2))/(2.0D0*
     $              LOG(PHAR(167)*PARA(1)/(PHAR(168)*XLQCD)))) 
     $                IEMIF2=IEMIF2+1
              ENDIF
              PTMAX=SQRT(PT2LST)
              CALL ARGETR(10-IEMIT)
              GOTO 170
            ELSE
              PTMAX=SQRT(PT2LST)
              CALL ARGETR(10-IEMIT)
              GOTO 170
            ENDIF
          ENDIF

 150    CONTINUE

        PARA(2)=PARA2
        MSTA(12)=MSTA12
      ENDIF

C...Now go forward again checking and count emissions above the matrix
C...element cutoff. Veto the event if any emissions below the cutoff is
C...found.
      DO 200 IEMIT=NEMIT,1,-1

C...Recall next saved partonic state
        CALL ARGETR(10-IEMIT)

C...Make one trial emission
        NP=IPART
        IF ( MSTA(28).NE.0 ) THEN
          DO 210 I=1,IPART
            IF ( .NOT.QQ(I) ) PT2GG(I)=PT(IEMIT+1)**2
 210      CONTINUE
        ENDIF
        IO = MHAR(161)-MHAR(162)-IEMIT
        PTMAX=PT(IEMIT+1)
 300    CALL AREVO1(PTMAX,PT(IEMIT))
        IF ( IPART.GT.NP ) THEN
          IF ( ARMECU(NP+1,IPART).GT.0.0D0 ) then
            PTMAX=SQRT(PT2LST)
            CALL ARGETR(10-IEMIT)
            IF(MHAR(188).EQ.2.AND.MHAR(162).EQ.0) GOTO 900
C            IF(LOG(PTMAX/DBLE(PARA(1)))/LOG(PTMAX/XLQCD).GT.PYR(0))THEN
              IEMIR=IEMIR+1
C            ENDIF
            GOTO 300
          ELSE
            GOTO 900
          ENDIF
        ENDIF

 200  CONTINUE

C...Generate next emission below the matrix element cutoff
      CALL ARGETR(10)
      IO=MHAR(161)-MHAR(162)-IEMIT
      NP=IPART
      IF ( MSTA(28).NE.0 ) THEN
        DO 410 I=1,IPART
          IF ( .NOT.QQ(I) ) PT2GG(I)=PT(IEMIT+1)**2
 410    CONTINUE
      ENDIF
      PTMAX=PT(1)
 400  CALL AREVO1(PTMAX,0.0D0)
      IF(IPART.GT.NP.AND.ARMECU(NP+1,IPART).GT.0.0D0.AND.
     $    MHAR(162).GT.0)THEN
        PTMAX=SQRT(PT2LST)
        CALL ARGETR(10)
c        IF(LOG(PTMAX/DBLE(PARA(1)))/LOG(PTMAX/XLQCD).GT.PYR(0))THEN
          IEMIR=IEMIR+1
c        ENDIF
        GOTO 400
      ENDIF

C...Calculate alpha_s factors
      ALPRAT=1.0D0
      ALPRUN=0.0D0
      IF(MHAR(188).EQ.2)THEN
c        PARA1=DBLE(PARA(1))
c        IF(MHAR(162).GT.0.AND.ABS(XLQCD-PARA1).GT.0.01D0)THEN
c          PARA(1)=REAL(XLQCD)
c        ENDIF
        DO 500 IEMIT=1,NEMIT
          STOT=ARMAS3(I1(IEMIT),I2(IEMIT),I3(IEMIT))
          ALPRAT=ALPRAT*ARALPS(PT2(IEMIT),STOT)/DBLE(PHAR(160))
 500    CONTINUE
        DO 600 IEMIT=1,NEMIT
c          ALPRUN=ALPRUN+LOG(PT2(IEMIT)/DBLE(PHAR(167)**2))*23.0D0/
c     $      (12.0D0*PARU(1))
          ALPRUN=ALPRUN+LOG(PT2(IEMIT)*XLQCD**2/
     $      (DBLE(PHAR(167)**2)*DBLE(PARA(1)**2)))*23.0D0/
     $      (12.0D0*PARU(1))
 600    CONTINUE
        ALPRUN=DBLE(PHAR(160))*ALPRUN
c        PARA(1)=REAL(PARA1)
      ENDIF

      XKFAC=1.0D0+DBLE(PHAR(160))/PARU(1)
      XKFAC2=1.0D0+DBLE(PHAR(160))/PARU(1)+
     $    (1.411D0+23.0D0/4.0D0*LOG(PARJ(129)))*
     $    (DBLE(PHAR(160))/PARU(1))**2

C...Generate the weight of the event
      IF(MHAR(188).EQ.3.AND.MHAR(162).GT.0)THEN
        IF(IEMIR.EQ.0)THEN
          ARNLO=ALPRAT*XKFAC2
        ELSE
          ARNLO=0.0D0
        ENDIF
c        ARNLO=ARNLO-XKFAC2+XKFAC*DBLE(IEMIF)+
c     $    DBLE(PHAR(160))*23.0D0/(6.0D0*PARU(1))*
c     $    DBLE(LOG(PHAR(167)/PHAR(168)))*DBLE(IEMIF2)-
c     $    DBLE(IEMIF*(IEMIF-1))/2.0D0+
c     $    ALPRUN
        ARNLO=ARNLO-XKFAC2+XKFAC*DBLE(IEMIF)+
     $    DBLE(PHAR(160))*23.0D0/(6.0D0*PARU(1))*
     $    DBLE(LOG(PHAR(167)*PARA(1)/(PHAR(168)*REAL(XLQCD))))*
     $    DBLE(IEMIF2)-DBLE(IEMIF*(IEMIF-1))/2.0D0+
     $    ALPRUN
      ELSEIF(MHAR(188).EQ.2.AND.MHAR(162).GT.0)THEN
        IF(IEMIR.EQ.0)THEN
          ARNLO=ALPRAT*XKFAC
        ELSE
          ARNLO=0.0D0
        ENDIF
        ARNLO=ARNLO+DBLE(IEMIF)-XKFAC+ALPRUN
      ELSEIF(MHAR(188).EQ.2)THEN
        ARNLO=ALPRAT*XKFAC
      ELSE
        ARNLO=1.0D0
      ENDIF
      IF(ARNLO.EQ.0.0D0) GOTO 900

      IF(NEMIT.GT.0) PHAR(122)=PT2(1)
      CALL ARCONT

      RETURN

 900  CALL ARGETR(10)
      ARNLO=0.0D0

      RETURN

C**** END OF ARNLO ****************************************************
      END
