C***********************************************************************
C $Id: arreco.f,v 3.14 2009/08/20 12:36:41 leif Exp $

      SUBROUTINE ARRECO(ISL,PT2I,SQQI,PROB,NSL)

C...ARiadne function REConstruct Possible emissions

C...Reconstruct all possible last emissions in the event record

      INCLUDE 'arimpl.f'
      INCLUDE 'arpart.f'
      INCLUDE 'ardips.f'
      INCLUDE 'arstrs.f'
      INCLUDE 'ardat1.f'
      INCLUDE 'arhide.f'
      INCLUDE 'arstrf.f'
      INCLUDE 'pyjets.f'
      INCLUDE 'pypars.f'

      DIMENSION ISL(3,MAXPAR),PT2I(MAXPAR),SQQI(MAXPAR),PROB(MAXPAR)

      INXTP(I)=IP3(IDO(I))
      IPRVP(I)=IP1(IDI(I))


      NSL=0

      DO 100 I=1,IPART
C...The easy case of gluon emission
        IF ( IFL(I).EQ.21 ) THEN
          IF ( MHAR(171).GE.0 ) THEN
            NSL=NSL+1
            ISL(1,NSL)=IPRVP(I)
            ISL(2,NSL)=I
            ISL(3,NSL)=INXTP(I)
            PT2I(NSL)=ARPT2G(ISL(1,NSL),I,ISL(3,NSL))
            SQQI(NSL)=-1.0D0
            PROB(NSL)=ARPROB(ISL(1,NSL),I,ISL(3,NSL),PT2I(NSL),.FALSE.)
          ELSE
            DO 120 I1=1,IPART-1
              IF ( I1.EQ.I ) GOTO 120
              DO 130 I3=I1+1,IPART
                IF ( I3.EQ.I ) GOTO 130
                NSL=NSL+1
                ISL(1,NSL)=I1
                ISL(2,NSL)=I
                ISL(3,NSL)=I3
                PT2I(NSL)=ARPT2G(ISL(1,NSL),ISL(2,NSL),ISL(3,NSL))
                SQQI(NSL)=-1.0D0
                PROB(NSL)=ARPROB(ISL(1,NSL),ISL(2,NSL),
     $               ISL(3,NSL),PT2I(NSL),.FALSE.)
 130          CONTINUE
 120        CONTINUE
          ENDIF
        ELSE
C...This is a quark. Find parton in this string which could have been
C...part of the emitting dipole
          IF ( MHAR(171).EQ.1.AND.(I.EQ.1.OR.I.EQ.IPART) ) GOTO 100
          ID=IDO(I)
          IF ( ID.GT.0 ) THEN
            IP=IP3(ID)
          ELSE
            ID=IDI(I)
            IP=IP1(ID)
          ENDIF
          IS=ISTR(ID)
C...Find corresponding antiquark in another string
          IF(.NOT.QEX(I))THEN
            DO 110 IQB=1,IPART
              IF ( MHAR(171).EQ.1.AND.(IQB.EQ.1.OR.IQB.EQ.IPART) )
     $             GOTO 110
              IF ( IFL(IQB).NE.-IFL(I) ) GOTO 110
              IF ( QEX(IQB) ) GOTO 110
              IP2=0
              IF ( IDO(IQB).GT.0 ) THEN
                IP2=IP3(IDO(IQB))
                IF ( ISTR(IDO(IQB)).EQ.IS ) GOTO 110
              ELSE
                IP2=IP1(IDI(IQB))
                IF ( ISTR(IDI(IQB)).EQ.IS ) GOTO 110
              ENDIF
C...Check that meighboring partons are not remnants of the same particle
C...FIXME works only in the case of one jet in DIS
              IF ( QEX(IP).AND.QEX(IP2).AND.INQ(IP).EQ.INQ(IP2) )
     $             GOTO 110

              NSL=NSL+1
              ISL(1,NSL)=IP
              ISL(2,NSL)=I
              ISL(3,NSL)=IQB
              PT2I(NSL)=ARIPT2(ISL(1,NSL),I,ISL(3,NSL))
              SQQI(NSL)=-1.0D0
              IF ( ABS(MSTA(20)).EQ.1 ) SQQI(NSL)=ARMAS2(I,IQB)
              IF ( ABS(MSTA(20)).EQ.2 )
     $             SQQI(NSL)=ARMAS2(I,IQB)-(BP(I,5)+BP(IQB,5))**2
              PROB(NSL)=ARPROB(ISL(1,NSL),I,ISL(3,NSL),
     $             PT2I(NSL),.FALSE.)
 110        CONTINUE
          ENDIF
C...Look for a possible sea quark emission
          IF ( IFL(I) .LT. 7 .AND. IFL(I) .GT. -7 
     $         .AND. INQ(IP) .LT. 0 .AND. QEX(IP)
     $         .AND..NOT. QEX(I)) THEN
            DO 140 IQB=1,IPART
              IF ( INQ(IP) .EQ. INQ(IQB) .AND. IQB .NE. IP)THEN
                NSL=NSL+1
                ISL(1,NSL) = IP
                ISL(2,NSL) = I
                ISL(3,NSL) = IQB
                PT2I(NSL) = ARPT2S(IP, I, IQB)
                SQQI(NSL) = -1.0D0
                PROB(NSL) = ARPROB(IP, I, IQB,PT2I(NSL),.FALSE.)
              ENDIF
 140        CONTINUE
          ENDIF
C...Look for an emission where a quark should be transformed into a remnant
          IF(IFL(I) .EQ. KFSAVE(1).AND..NOT.QEX(I))THEN
            IPR = 0
            DO 210 J = 1,IPART
              IF(INQ(J) .LT. 0 .AND. K(-INQ(J),3) .EQ. 1)THEN
                IF(IPR.GT.0)THEN
                  GOTO 200
                ELSE
                  IPR = J
                ENDIF
              ENDIF
 210        CONTINUE
            IF(IPR.EQ.0) GOTO 200
            IF(QQ(MAXPAR-4))THEN
              QSEA = .FALSE.
              CALL ARRFLV(IFL(MAXPAR-4),-IFL(I),QSEA,KFR1,KFR2,KFH)
              IF(QSEA) GOTO 200
            ENDIF
            IDR=IDO(IPR)
            IF ( IDR.LE.0 ) THEN
              IDR=IDI(IPR)
            ENDIF
            ISR=ISTR(IDR)
            IF(ISR.NE.IS)THEN
              NSL=NSL+1
              ISL(1,NSL) = IPR
              ISL(2,NSL) = I
              ISL(3,NSL) = MAXPAR-4
              PT2I(NSL) = ARPT2S(IPR, I , MAXPAR-4)
              SQQI(NSL) = -1.0D0
              PROB(NSL) = ARPROB(IPR, I, MAXPAR-4,PT2I(NSL),.FALSE.)
            ENDIF
          ENDIF
 200      CONTINUE
          IF(IFL(I) .EQ. KFSAVE(2).AND..NOT.QEX(I))THEN
            IPR = 0
            DO 230 J = 1,IPART
              IF(INQ(J) .LT. 0 .AND. K(-INQ(J),3) .EQ. 2)THEN
                IF(IPR.GT.0)THEN
                  GOTO 220
                ELSE
                  IPR = J
                ENDIF
              ENDIF
 230        CONTINUE
            IF(QQ(MAXPAR-3))THEN
              QSEA = .FALSE.
              CALL ARRFLV(IFL(MAXPAR-3),-IFL(I),QSEA,KFR1,KFR2,KFH)
              IF(QSEA) GOTO 220
            ENDIF
            IDR=IDO(IPR)
            IF ( IDR.LE.0 ) THEN
              IDR=IDI(IPR)
            ENDIF
            ISR=ISTR(IDR)
            IF(ISR.NE.IS)THEN
              NSL=NSL+1
              ISL(1,NSL) = IPR
              ISL(2,NSL) = I
              ISL(3,NSL) = MAXPAR-3
              PT2I(NSL) = ARPT2S(IPR, I , MAXPAR-3)
              SQQI(NSL) = -1.0D0
              PROB(NSL) = ARPROB(IPR, I, MAXPAR-3,PT2I(NSL),.FALSE.)
            ENDIF
          ENDIF
 220      CONTINUE
        ENDIF
 100  CONTINUE

      RETURN
      
C**** END OF ARRECO ****************************************************
      END
